

/* asu ihex2bin ver 1.11 */
/* (C) Masaki Oba 2017 */
/*  2-Clause BSD License. */
/* compile
   check only bcc32
   Windows Borland(#define WINDOWS)(Convert to SJIS)
      bcc32 -DWINDOWS ihex2bin.c ihex.c

   no check
   UNIX cc(#define UNIX)
      cc -o ihex2bin -DMACOSX ihex2bin.c ihex.c

   no check
   UNIX gcc(#define UNIX)
      gcc -o ihex2bin ihex.c

   no check
   Windows Microsoft(#define WINDOWS)(Convert to SJIS)
      cl -DWINDOWS ihex2bin.c ihex.c

   no check
   Mac OS X XCode(#define MACOSX)(OS no namae igai wa UNIX to onaji)
      cc -o ihex2bin -DMACOSX ihex2bin.c ihex.c

   no check
   MS-DOS DJGPP(MS-DOS gcc)(#define GO32)(Convert to SJIS)
      gcc -DGO32 ihex2bin.c ihex.c
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>

/*
#ifdef MSDOSREAL
#include <io.h>
#endif
*/

#ifdef MACOSX
#define OS "Mac OS X"
#endif

#ifdef WINDOWS
#include <io.h>
#define MSDOSSS
#define OS "Windows"
#endif

#ifdef GO32
#define MSDOSSS
#define OS "MS-DOS go32(80386)"
#endif
#ifdef MSDOSREAL
#define MSDOSSS
#define OS "MS-DOS real mode(8086)"
#endif

#ifndef WINDOWS
#ifndef GO32
#ifndef MSDOSREAL
#ifndef MACOSX
#define OS "UNIX"
#include <unistd.h>
#endif
#endif
#endif
#endif

#define  VERSION "1.11"
#define  NENGOU  "2017"


#define  ERROR -1

int hex(char *inpname,unsigned long *minad,unsigned long *maxad);

extern unsigned char mem[65536];

int adenflag,startflag;
long start = (long)-1;
long endad = (long)-1;
char kakuchousi[100];
char outname[2000];


#ifdef ROMA_ONLY
#undef ROMAJI
#define ROMAJI
#endif

#ifdef ROMAJI
int Alpf = 1;	/* 0:kanji mode  1:roma ji mode */
#else
int Alpf = 0;	/* 0:kanji mode  1:roma ji mode */
#endif

void eprintf(char *str)
{
  fprintf(stderr,str);
  fprintf(stderr,"\n%c",7);
}

void eprintf2(char *str,char *str2)
{
  fprintf(stderr,str,str2);
  fprintf(stderr,"\n%c",7);
}

void setumei(void) 
{
  /* setumei hyouji */
if(!Alpf){
/*KANJI*/ printf("CeHEXt@CoCit@Cւ̃Ro[^[\n\n");
/*KANJI*/ printf("g: ihex2bin [-s<16il> [-e<16il>] [-k<o͊gq>] [-o<݃t@C>] [-AN] Ǎt@C\n");
/*KANJI*/ printf("   xxx-s,-eł16iB-kł͊gq̕B-oł̓t@C\n");
/*KANJI*/ printf("     -oxxx  (pX+)t@CBႦ -o/abc/abc.bin\n");
/*KANJI*/ printf("     -sxxx  JnԒnBႦ -s20A Ȃ 20AԒn\n");
/*KANJI*/ printf("     -exxx  IԒnBႦ -e5CA Ȃ 5CAԒn܂\n");
/*KANJI*/ printf("            (-s  -e ̓^[Qbg̃Ԓnw肵܂B)\n");
/*KANJI*/ printf("            (:ǂނ킯ł͂ȂAt@Cǂ)\n");
/*KANJI*/ printf("     -kxxx  o̓t@C̊gqwB-kCOM Ȃ gq.COMɂ\n");
#ifdef ROMAJI
/*KANJI*/ printf("     -A  G[̃bZ[W[}ŏo͂B(ftHg)\n");
/*KANJI*/ printf("     -N  G[̃bZ[WSpŏo͂B\n");
#else
/*KANJI*/ printf("     -A  G[̃bZ[W[}ŏo͂B\n");
/*KANJI*/ printf("     -N  G[̃bZ[WSpŏo͂B(ftHg)\n");
#endif
}
else{
printf("intel HEX file to binary file converter.(MAX FFFF)\n\n");
printf("Usage: ihex2bin [-s<hexnumber>] [-e<hexnumber>] [-k<extension>] [-o<writefile>] [-AN] readfile\n");
printf("   xxx -s,-e hex numbers. -k filename extension. -o filename\n");
printf("     -oxxx  (path+)filename.  for example -o/abc/abc.bin\n");
printf("     -sxxx  start address(hex).  for example -s20A\n");
printf("     -exxx  end address(hex).  for example -e5ca\n");
printf("     -kxxx  output filename extension.  for example -kCOM\n");
#ifdef ROMAJI
printf("     -A  romanized character message(default)\n");
#ifndef ROMA_ONLY
printf("     -N  Japanese message\n");
#endif
#else
printf("     -A  romanized character message\n");
printf("     -N  Japanese message(default)\n");
#endif
}
printf("\n     asu ihex2bin ver ");
printf(VERSION);
printf(" for %s",OS);
printf(" (C) Masaki Oba ");
printf(NENGOU);
printf("\n");
}

unsigned xtou(char *str)
{
  /* 16sinsuu mojiretu -> unsigned */
  unsigned s;
  char c;
  s=0;
  while(*str !=0){
    if(('a'-1)< *str && *str < ('f'+1))
      c= (*str & 0x9f)+9;
    else if(('A'-1)< *str && *str <('F'+1))
      c= (*str & 0xbf)+9;
    else if(('0'-1)< *str && *str <('9'+1))
      c=*str & 0x0f;
    else 
      c=0;
    s=s*16+c;
    ++str;
  }
  return s;
}

int iseigo(unsigned char ccc)
{
  /* eiji? */
  if((ccc>64 && ccc<91) || (ccc>96 && ccc<123)) return 0; else return -1;
}

int option(short argc,char **argv /* ,char **symname */)
{
  int i;
#ifndef GETOPT
  int tugia;
  int lof;	/* arg option flag */
#endif

#ifdef GETOPT
  int c;


  /* getopt() use */
  int digit_optind = 0;

  while (1){
     int this_option_optind = optind ? optind : 1;
     c = getopt(argc, argv, "o:mbonl:e:s:S:y:KCHAdhikug");
     if (c == -1)
       break;
     switch (c){
#else
  /* getopt() not use */
  for(i=1;i<argc-1;++i){
    tugia = 0;
    lof = 0;
    if(argv[i][tugia]=='-'){
     while(1){
       switch (argv[i][tugia+1]){
#endif

         case 'e':
#ifdef GETOPT
           endad=xtou(optarg);
#else
           if(!argv[i][tugia+2]){
             ++i;
             if(i>=argc-1){
               endad=0;
             }
             else{
               if(argv[i][0]!='-')
                 endad=xtou(&argv[i][0]);
               else{
                 endad = 0;
                 --i;
               }
             }
           }
           else{
             endad=xtou(&argv[i][tugia+2]);
           }
           lof = 1;	/* arg option flag */
#endif
           adenflag=1;
           break;
         case 'k':
#ifdef GETOPT
           strcpy(kakuchousi,optarg);
#else
           if(!argv[i][tugia+2]){
             ++i;
             if(i>=argc-1){
             }
             else{
               if(argv[i][0]!='-'){
                 strcpy(kakuchousi,&argv[i][0]);
               }
               else{
                 --i;
               }
             }
           }
           else{
             strcpy(kakuchousi,&argv[i][tugia+2]);
           }
           lof = 1;	/* arg option flag */
#endif
           break;
         case 'A':
           Alpf = 1;	/* roma ji mode */
           break;
         case 's':
#ifdef GETOPT
           start=xtou(optarg);
#else
           if(!argv[i][tugia+2]){
             ++i;
             if(i>=argc-1){
               start=0;
             }
             else{
               if(argv[i][0]!='-')
                 start=xtou(&argv[i][0]);
               else{
                 start = 0;
                 --i;
               }
             }
           }
           else{
             start=xtou(&argv[i][tugia+2]);
           }
           lof = 1;
#endif
           startflag=1;
           break;
         case 'o':
#ifdef GETOPT
           strcpy(outname,optarg);
#else
           if(!argv[i][tugia+2]){
             ++i;
             if(i>=argc-1){
               start=0;
             }
             else{
               if(argv[i][0]!='-'){
                 strcpy(outname,&argv[i][0]);
               }
               else{
                 outname[0] = 0;
                 start = 0;
                 --i;
               }
             }
           }
           else{
             strcpy(outname,&argv[i][tugia+2]);
           }
           lof = 1;
#endif
           break;
         case 'N':
#ifndef ROMA_ONLY
           Alpf = 0;
#endif
           break;
  
         default:
#ifdef GETOPT
           if(Alpf){
             fprintf (stderr,"Invalid option '-%c'",c);
             return -1;
           }
           else{
/*KANJI*/    fprintf(stderr,"݂ȂIvVłB'-%c'",c);
             return -1;
           }
#else
           if(Alpf){
             fprintf(stderr,"Invalid option '-%c'",argv[i][tugia+2]);
             return -1;
           }
           else{
/*KANJI*/    fprintf(stderr,"݂ȂIvVłB'-%c'",argv[i][tugia+2]);
             return -1;
           }
#endif
      }
#ifndef GETOPT
       if(lof){
         break;
       }
       else
       if(iseigo(argv[i][tugia+2]))
         break;
       else
         ++tugia;
     }
    }
    else{
      if(Alpf){
        eprintf2("Invalid option '%.5s'",&argv[i][0]);
      }
      else{
/*KANJI*/        eprintf2("݂ȂIvVłB'%.5s'",&argv[i][0]);
      }
      return -1;
    }
#endif
  }
  return 0;
}

int changeoutname(char *fname)
{
  int len,i,ka;
  len = strlen(fname);

  if(len <= 0){
    return -1;
  }

  for(i=len-1;i>=0;--i){
    if(fname[i] == '.'){
      fname[i] = 0;
      break;
    }
    if(fname[i] == '/' || fname[i] == '\\'){
      break;
    }
  }

  if(kakuchousi[0]){
    if(kakuchousi[0] != '.'){
      strcat(fname,".");
    }
    strcat(fname,kakuchousi);
  }
  else{
    strcat(fname,".bin");
  }
  return 0;
}

int main(int argc,char **argv)
{
  int wsize;
  char *inpname;
  int fd;
  long ad_start;
  long ad_end;

  kakuchousi[0] = 0;
  outname[0] = 0;

  if(argc<2){
    setumei();
    return 1;
  }

  if(argv[argc-1][0]=='-'){
    if(argv[argc-1][1]=='A' || argv[argc-1][1]=='N'){
      if(argv[argc-1][1]=='A'){
        Alpf = 1;
      }
      else{
        Alpf = 0;
      }
    }
    setumei();
    return 1;
  }

  if(argc>1){
    if(option(argc,argv)){
      return -1;
    }
  }

  inpname = argv[argc-1];

  if(hex(inpname,(unsigned long *)&ad_start,(unsigned long *)&ad_end)){
    return -1;
  }

  if(startflag){
    if(start >= 0xffff){
      if(Alpf){
        eprintf("-s wrong. start adress > 0xFFFF.");
      }
      else{
/*KANJI*/          eprintf("-s ̊JnԒnwl0xFFFF傫B");
      }
      return -1;
    } 
  }

  if(adenflag){
    if(endad < (long)0){
      if(Alpf){
        eprintf("-e wrong. end adress < 0.");
      }
      else{
/*KANJI*/          eprintf("-s ̊JnԒnwl0菬B");
      }
      return -1;
    } 
    if(endad >= (long)0xffff){
      if(Alpf){
        eprintf("-e wrong. end adress > 0xFFFF.");
      }
      else{
/*KANJI*/          eprintf("-s ̊JnԒnwl0xFFFF傫B");
      }
      return -1;
    } 
     ad_end = endad;
  }

  if(startflag){
    if(start < (long)0){
      if(Alpf){
        eprintf("-s wrong. start adress < 0.");
      }
      else{
/*KANJI*/          eprintf("-s ̊JnԒnwl0菬B");
      }
      return -1;
    } 
    if(start >= 0xffff){
      if(Alpf){
        eprintf("-s wrong. start adress > -e end adress.");
      }
      else{
/*KANJI*/          eprintf("-s ̊JnԒnwl-ȅIԒn傫B");
      }
      return -1;
    } 
    ad_start = start;
  }

  if(outname[0]){
    if(kakuchousi[0]){
      changeoutname(outname);
    }
  }
  else{
    strcpy(outname,inpname);
    changeoutname(outname);
  }

#ifdef WINDOWS
  if(-1 == (fd = open(outname,O_WRONLY | O_CREAT | O_TRUNC | O_BINARY,S_IREAD|S_IWRITE))){
#else
#ifdef GO32
  if(-1 == (fd = open(outname,O_WRONLY | O_CREAT | O_TRUNC | O_BINARY,S_IREAD|S_IWRITE))){
#else
  if(-1 == (fd = open(outname,O_WRONLY | O_CREAT | O_TRUNC,S_IREAD|S_IWRITE))){
#endif
#endif
#if 0
  }}
#endif

    if(Alpf){
      fprintf(stderr,"file cannot open[%s]\n",outname);
    }
    else{
/*KANJI*/      fprintf(stderr,"t@CJ܂B[%s]\n",outname);
    }
    return -1;
  }

  fprintf(stderr,"\tasu ihex2bin   ver");

  fprintf(stderr,VERSION);
  fprintf(stderr,"   for %s",OS);
  fprintf(stderr,"\n\t\t\t(C) Masaki Oba  ");
  fprintf(stderr,NENGOU);
  fprintf(stderr,"\n");

  wsize = ad_end - ad_start + 1;
  printf("start=%lX , ad_end=%X  ,size=0x%X (%ld)\n",ad_start,ad_end,wsize,wsize);

  if(wsize != write(fd,&mem[ad_start],ad_end - ad_start + 1)){
    printf("Error: can't write data[%s] \n",outname);
    close(fd);
    return 8;
  }
  close(fd);

  if(chmod(outname,S_IREAD|S_IWRITE) != 0){
    printf("Error: Unable to change file mode(read and write).\n");
  }

  printf("output [%s]\n",outname);

  return 0;
}

